/*
 * Created on 28-06-2005
 *
 */

/**
 * @author Valeria
 */
public class Mensaje {
    //    new Mensaje() Mensaje m = new Mensaje() Crea el mensaje
    //    void recibir(Paquete p) m.recibir(p) Recibe paquete y lo agrega a lista
    // enlazada(si est repetido lo ignora)
    //    String mensaje(int x) m.escribir() devuelve mensaje completo (de x
    // partes) o null si no est completo

    public Paquete primero;

    public Mensaje() {
        primero = null;
    }

    public void recibir(Paquete p) {
        //Caso lista vacia
        if (primero == null) {
            primero = p;
            return;
        }

        //Reviso si ya estaba
        Paquete aux = primero;
        while (aux != null) {
            if (aux.id == p.id)
                return;
            aux = aux.sgte;
        }
        //Si no estaba lo agrego
        p.sgte = primero;
        primero = p;

    }

    public String mensaje(int x) {
        String resultado = "";
        for (int i = 1; i <= x; i++) {
            //busco en toda la lista el paquete i
            Paquete aux = primero;
            while (aux != null) {
                if (aux.id == i) {
                    resultado += aux.info;
                    break;
                }
                aux = aux.sgte;
            }
            //Si no estaba la iesima parte, no esta completo el mensaje
            if (aux == null) {
                return null;
            }
        }

        return resultado;
    }

    public static void main(String args[]) {
        Mensaje m = new Mensaje();

        Paquete p1 = new Paquete(1, "a ");
        Paquete p2 = new Paquete(2, "long ");
        Paquete p3 = new Paquete(3, "time ");
        Paquete p4 = new Paquete(4, "ago ");
        Paquete p5 = new Paquete(5, "in ");
        Paquete p6 = new Paquete(6, "a ");
        Paquete p7 = new Paquete(7, "galaxy ");
        Paquete p8 = new Paquete(8, "far, ");
        Paquete p9 = new Paquete(9, "far ");
        Paquete p10 = new Paquete(10, "away.");

        m.recibir(p8);
        m.recibir(p10);
        m.recibir(p1);
        m.recibir(p3);
        m.recibir(p4);
        m.recibir(p9);
        System.out.println("El mensaje completo es " + m.mensaje(10));

        m.recibir(p2);
        m.recibir(p7);
        m.recibir(p5);
        m.recibir(p4);
        m.recibir(p5);
        m.recibir(p6);

        System.out.println("El mensaje completo es \"" + m.mensaje(10) + "\"");
    }
}